/**
 * 
 */
package net.bigeon.gclc.swt.tools;

import org.eclipse.swt.widgets.Widget;

import net.bigeon.gclc.manager.PipedConsoleOutput;
import net.bigeon.gclc.manager.forwarding.AOutputForwardRunnable;
import net.bigeon.gclc.swt.ConsoleOutputDisplay;

/** The local implementation of the forwarding runnable.
 *
 * @author Emmanuel Bigeon */
public final class ToSWTConsoleForwardRunnable
        extends AOutputForwardRunnable {
    /** The running status. */
    private boolean                    running = true;
    /** The console output. */
    private final PipedConsoleOutput   out;
    /** The console output display. */
    private final ConsoleOutputDisplay display;
    /** The actual SWT component. */
    private final Widget               element;

    /** Create the forwarding runnable.
     * 
     * @param manager the manager
     * @param display the display
     * @param element the composite */
    public ToSWTConsoleForwardRunnable(final PipedConsoleOutput manager,
                                       final ConsoleOutputDisplay display,
                                       final Widget element) {
        super(manager);
        out = manager;
        this.display = display;
        this.element = element;
    }

    /* (non-Javadoc)
     * @see
     * net.bigeon.gclc.utils.AOutputForwardRunnable#forwardLine(java.lang.String) */
    @Override
    protected void forwardLine(final String m) {
        display.appendLine(m);
    }

    /* (non-Javadoc)
     * @see net.bigeon.gclc.utils.AOutputForwardRunnable#isRunning() */
    @Override
    protected boolean isRunning() {
        return running && !element.isDisposed();
    }

    /** Set the running status.
     * 
     * @param running the running to set */
    public void setRunning(final boolean running) {
        this.running = running;
    }

    /** Get the output.
     * 
     * @return the currently forwarded output */
    public PipedConsoleOutput getOuput() {
        return out;
    }
}